From 598201dad54ce7bdcdd8126f23664ac73e14d829 Mon Sep 17 00:00:00 2001
From: Felipe Castro <fefcas@gmail.com>
Date: Thu, 22 Aug 2013 15:50:58 -0300
Subject: [PATCH 26/26] adding dump program, fixed for missing fields

---
 Makefile.am                  |    5 +-
 configure.ac                 |   21 +-
 examples/Makefile.am         |   16 +-
 examples/dump.c              |  326 ++++
 examples/dump_objects.in.c   |  180 +++
 examples/dump_variables.in.c |   72 +
 src/Makefile.am~             |   77 -
 src/add_object.c~            |  470 ------
 src/bits.c~                  | 1069 -------------
 src/bits.h                   |   14 -
 src/bits.h~                  |  209 ---
 src/classes.c~               |  194 ---
 src/classes.h~               |   44 -
 src/common.c                 |    9 +-
 src/common.h                 |   43 +-
 src/common.h~                |   98 --
 src/decode.c~                |  795 ----------
 src/decode.h~                |  270 ----
 src/decode_r13_r15.c~        |  285 ----
 src/decode_r13_r15.h~        |   54 -
 src/decode_r2004.c~          |  721 ---------
 src/decode_r2004.h~          |   68 -
 src/decode_r2007.c~          |  955 ------------
 src/dwg.c                    |  279 ++--
 src/dwg.h                    |   48 +-
 src/dwg.h~                   | 3055 ------------------------------------
 src/dwg.spec                 |  124 +-
 src/dwg.spec~                | 3542 ------------------------------------------
 src/encode.c~                | 1127 --------------
 src/encode.h~                |   47 -
 src/handle.c~                |  252 ---
 src/handle.h~                |   45 -
 src/handles.c~               |  172 --
 src/header.c~                |  111 --
 src/header.h~                |   48 -
 src/header_variables.spec~   |  557 -------
 src/object.c~                |  454 ------
 src/object.h~                |   49 -
 src/print.c~                 |  403 -----
 src/print.h~                 |   31 -
 src/resolve_pointers.c~      |   81 -
 src/resolve_pointers.h~      |   45 -
 src/section_locate.c~        |  152 --
 src/section_locate.h~        |   46 -
 src/section_locator.c~       |  144 --
 src/section_locator.h~       |   40 -
 src/section_resolve.c~       |  128 --
 47 files changed, 848 insertions(+), 16127 deletions(-)
 create mode 100644 examples/dump.c
 create mode 100644 examples/dump_objects.in.c
 create mode 100644 examples/dump_variables.in.c
 delete mode 100644 src/Makefile.am~
 delete mode 100644 src/add_object.c~
 delete mode 100644 src/bits.c~
 delete mode 100644 src/bits.h~
 delete mode 100644 src/classes.c~
 delete mode 100644 src/classes.h~
 delete mode 100644 src/common.h~
 delete mode 100644 src/decode.c~
 delete mode 100644 src/decode.h~
 delete mode 100644 src/decode_r13_r15.c~
 delete mode 100644 src/decode_r13_r15.h~
 delete mode 100644 src/decode_r2004.c~
 delete mode 100644 src/decode_r2004.h~
 delete mode 100644 src/decode_r2007.c~
 delete mode 100644 src/dwg.h~
 delete mode 100644 src/dwg.spec~
 delete mode 100644 src/encode.c~
 delete mode 100644 src/encode.h~
 delete mode 100644 src/handle.c~
 delete mode 100644 src/handle.h~
 delete mode 100644 src/handles.c~
 delete mode 100644 src/header.c~
 delete mode 100644 src/header.h~
 delete mode 100644 src/header_variables.spec~
 delete mode 100644 src/object.c~
 delete mode 100644 src/object.h~
 delete mode 100644 src/print.c~
 delete mode 100644 src/print.h~
 delete mode 100644 src/resolve_pointers.c~
 delete mode 100644 src/resolve_pointers.h~
 delete mode 100644 src/section_locate.c~
 delete mode 100644 src/section_locate.h~
 delete mode 100644 src/section_locator.c~
 delete mode 100644 src/section_locator.h~
 delete mode 100644 src/section_resolve.c~
 delete mode 100644 src/section_resolve.h~

diff --git a/Makefile.am b/Makefile.am
index ab9538f..71b45f6 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -19,6 +19,9 @@
 
 ACLOCAL_AMFLAGS = -I m4
 
-SUBDIRS = src doc examples bindings
+SUBDIRS = src doc examples
+if BINDING
+SUBDIRS += bindings
+endif
 
 EXTRA_DIST = README README-alpha
diff --git a/configure.ac b/configure.ac
index f5f3abf..ba411d3 100644
--- a/configure.ac
+++ b/configure.ac
@@ -54,6 +54,8 @@ AC_FUNC_MALLOC
 AC_FUNC_REALLOC
 AC_FUNC_STAT
 
+dnl AC_DISABLE_OPTION_CHECKING
+
 dnl Feature: --enable-trace
 AC_ARG_ENABLE([trace],[AS_HELP_STRING([--enable-trace],[
     Enable runtime tracing (default: no).  When enabled, the environment
@@ -72,13 +74,18 @@ dnl Test support.
 AM_CONDITIONAL([HAVE_LIBPS],[test yes = "$libredwg_have_libps" &&
                              test yes = "$ac_cv_header_libps_pslib_h"])
 
-dnl for SWIG - should be optional
-AM_PATH_PYTHON([2.3])
-AX_PKG_SWIG([1.3.17], [], [ AC_MSG_ERROR([SWIG is required to build..]) ])
+dnl Feature: --enable-binding with SWIG - should be optional
+AC_ARG_ENABLE([binding],
+	      [AS_HELP_STRING([--enable-binding],[Build binding wrappers (default: no).])],
+	      [],
+	      [enable_binding=no])
+AM_CONDITIONAL([BINDING], [test "x$enable_binding" != "xno"])
+
+AM_COND_IF([BINDING], [AM_PATH_PYTHON([2.3])])
+AM_COND_IF([BINDING], [AX_PKG_SWIG([1.3.17], [], [ AC_MSG_ERROR([SWIG is required to build..]) ]) ])
 dnl AX_SWIG_ENABLE_CXX
 dnl SWIG_MULTI_MODULE_SUPPORT
-SWIG_PYTHON
-
+AM_COND_IF([BINDING], [SWIG_PYTHON])
 
 
 dnl Write it out!
@@ -88,10 +95,10 @@ AC_CONFIG_FILES([
 	src/Makefile
 	doc/Makefile
 	examples/Makefile
-	bindings/Makefile
-	bindings/python/Makefile
 ])
 
+AM_COND_IF([BINDING], [AC_CONFIG_FILES([bindings/Makefile bindings/python/Makefile])])
+
 AC_OUTPUT
 
 dnl configure.ac ends here
diff --git a/examples/Makefile.am b/examples/Makefile.am
index 0b04d35..4c30739 100644
--- a/examples/Makefile.am
+++ b/examples/Makefile.am
@@ -17,7 +17,7 @@
 ## You should have received a copy of the GNU General Public License
 ## along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
-check_PROGRAMS = load_dwg get_bmp test testSVG
+check_PROGRAMS = load_dwg get_bmp test testSVG dump
 
 if HAVE_LIBPS
 check_PROGRAMS += dwg_ps
@@ -36,6 +36,10 @@ load_dwg_SOURCES = load_dwg.c
 
 get_bmp_SOURCES = get_bmp.c
 
+dump_SOURCES = dump.c
+
+BUILT_SOURCES = dump_objects.c dump_variables.c
+
 AM_CFLAGS = -Wextra -I$(top_srcdir)/src
 
 TESTS_ENVIRONMENT = \
@@ -44,4 +48,12 @@ TESTS_ENVIRONMENT = \
 
 TESTS = alive.test
 
-EXTRA_DIST = example.dwg sample.dwg suffix.c load_dwg.py $(TESTS)
+EXTRA_DIST = example.dwg sample.dwg suffix.c load_dwg.py dump_objects.in.c  dump_variables.in.c $(TESTS)
+
+dump_objects.c: dump_objects.in.c
+	$(CPP) -P $(AM_CFLAGS) dump_objects.in.c > dump_objects.c
+	indent dump_objects.c
+
+dump_variables.c: dump_variables.in.c
+	$(CPP) -P $(AM_CFLAGS) dump_variables.in.c > dump_variables.c
+	indent dump_variables.c
diff --git a/examples/dump.c b/examples/dump.c
new file mode 100644
index 0000000..554907c
--- /dev/null
+++ b/examples/dump.c
@@ -0,0 +1,326 @@
+/*****************************************************************************/
+/*  LibreDWG - free implementation of the DWG file format                    */
+/*                                                                           */
+/*  Copyright (C) 2013 Free Software Foundation, Inc.                        */
+/*                                                                           */
+/*  This library is free software, licensed under the terms of the GNU       */
+/*  General Public License as published by the Free Software Foundation,     */
+/*  either version 3 of the License, or (at your option) any later version.  */
+/*  You should have received a copy of the GNU General Public License        */
+/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.    */
+/*****************************************************************************/
+
+/**
+ *     \file       dump.c
+ *     \brief      Dump functions
+ *     \author     written by Rodrigo Rodrigues da Silva
+ *     \author     modified by Felipe E. F. de Castro
+ *     \version    
+ *     \copyright  GNU General Public License (version 3 or later)
+ */
+
+#define SHOW_CLA
+#define SHOW_VAR
+#define SHOW_OBJ
+
+#include <stdio.h>
+#include <stdlib.h>
+
+#include "dwg.h"
+#include "logging.h"
+
+#include "dump_variables.c"
+
+#include "dump_objects.c"
+
+void
+dump_objects (Dwg_Data * dwg)
+{
+  unsigned int i;
+  Dwg_Object *obj;
+  Bit_Chain dat;
+
+  dat.chain = (unsigned char *) malloc (1000 * sizeof (char));
+  dat.size = 1000;
+  dat.version = dwg->header.version;
+
+  for (i = 0; i < dwg->num_objects; i++)
+    {
+      obj = &dwg->object[i];
+      printf ("[%u] ", i);
+      dat.byte = 0;
+      dat.bit = 0;
+      switch (obj->type)
+	{
+	case DWG_TYPE_TEXT:
+	  dump_TEXT (&dat, obj);
+	  break;
+	case DWG_TYPE_ATTRIB:
+	  dump_ATTRIB (&dat, obj);
+	  break;
+	case DWG_TYPE_ATTDEF:
+	  dump_ATTDEF (&dat, obj);
+	  break;
+	case DWG_TYPE_BLOCK:
+	  dump_BLOCK (&dat, obj);
+	  break;
+	case DWG_TYPE_ENDBLK:
+	  dump_ENDBLK (&dat, obj);
+	  break;
+	case DWG_TYPE_SEQEND:
+	  dump_SEQEND (&dat, obj);
+	  break;
+	case DWG_TYPE_INSERT:
+	  dump_INSERT (&dat, obj);
+	  break;
+	case DWG_TYPE_MINSERT:
+	  dump_MINSERT (&dat, obj);
+	  break;
+	case DWG_TYPE_VERTEX_2D:
+	  dump_VERTEX_2D (&dat, obj);
+	  break;
+	case DWG_TYPE_VERTEX_3D:
+	  dump_VERTEX_3D (&dat, obj);
+	  break;
+	case DWG_TYPE_VERTEX_MESH:
+	  dump_VERTEX_MESH (&dat, obj);
+	  break;
+	case DWG_TYPE_VERTEX_PFACE:
+	  dump_VERTEX_PFACE (&dat, obj);
+	  break;
+	case DWG_TYPE_VERTEX_PFACE_FACE:
+	  dump_VERTEX_PFACE_FACE (&dat, obj);
+	  break;
+	case DWG_TYPE_POLYLINE_2D:
+	  dump_POLYLINE_2D (&dat, obj);
+	  break;
+	case DWG_TYPE_POLYLINE_3D:
+	  dump_POLYLINE_3D (&dat, obj);
+	  break;
+	case DWG_TYPE_ARC:
+	  dump_ARC (&dat, obj);
+	  break;
+	case DWG_TYPE_CIRCLE:
+	  dump_CIRCLE (&dat, obj);
+	  break;
+	case DWG_TYPE_LINE:
+	  dump_LINE (&dat, obj);
+	  break;
+	case DWG_TYPE_DIMENSION_ORDINATE:
+	  dump_DIMENSION_ORDINATE (&dat, obj);
+	  break;
+	case DWG_TYPE_DIMENSION_LINEAR:
+	  dump_DIMENSION_LINEAR (&dat, obj);
+	  break;
+	case DWG_TYPE_DIMENSION_ALIGNED:
+	  dump_DIMENSION_ALIGNED (&dat, obj);
+	  break;
+	case DWG_TYPE_DIMENSION_ANG3PT:
+	  dump_DIMENSION_ANG3PT (&dat, obj);
+	  break;
+	case DWG_TYPE_DIMENSION_ANG2LN:
+	  dump_DIMENSION_ANG2LN (&dat, obj);
+	  break;
+	case DWG_TYPE_DIMENSION_RADIUS:
+	  dump_DIMENSION_RADIUS (&dat, obj);
+	  break;
+	case DWG_TYPE_DIMENSION_DIAMETER:
+	  dump_DIMENSION_DIAMETER (&dat, obj);
+	  break;
+	case DWG_TYPE_POINT:
+	  dump_POINT (&dat, obj);
+	  break;
+	case DWG_TYPE__3DFACE:
+	  dump__3DFACE (&dat, obj);
+	  break;
+	case DWG_TYPE_POLYLINE_PFACE:
+	  dump_POLYLINE_PFACE (&dat, obj);
+	  break;
+	case DWG_TYPE_POLYLINE_MESH:
+	  dump_POLYLINE_MESH (&dat, obj);
+	  break;
+	case DWG_TYPE_SOLID:
+	  dump_SOLID (&dat, obj);
+	  break;
+	case DWG_TYPE_TRACE:
+	  dump_TRACE (&dat, obj);
+	  break;
+	case DWG_TYPE_SHAPE:
+	  dump_SHAPE (&dat, obj);
+	  break;
+	case DWG_TYPE_VIEWPORT:
+	  dump_VIEWPORT (&dat, obj);
+	  break;
+	case DWG_TYPE_ELLIPSE:
+	  dump_ELLIPSE (&dat, obj);
+	  break;
+	case DWG_TYPE_SPLINE:
+	  dump_SPLINE (&dat, obj);
+	  break;
+	case DWG_TYPE_REGION:
+	  dump_REGION (&dat, obj);
+	  break;
+	case DWG_TYPE_3DSOLID:
+	  dump__3DSOLID (&dat, obj);
+	  break;
+	  /* Check the type of the object */
+	case DWG_TYPE_BODY:
+	  dump_BODY (&dat, obj);
+	  break;
+	case DWG_TYPE_RAY:
+	  dump_RAY (&dat, obj);
+	  break;
+	case DWG_TYPE_XLINE:
+	  dump_XLINE (&dat, obj);
+	  break;
+	case DWG_TYPE_DICTIONARY:
+	  dump_DICTIONARY (&dat, obj);
+	  break;
+	case DWG_TYPE_MTEXT:
+	  dump_MTEXT (&dat, obj);
+	  break;
+	case DWG_TYPE_LEADER:
+	  dump_LEADER (&dat, obj);
+	  break;
+	case DWG_TYPE_TOLERANCE:
+	  dump_TOLERANCE (&dat, obj);
+	  break;
+	case DWG_TYPE_MLINE:
+	  dump_MLINE (&dat, obj);
+	  break;
+	case DWG_TYPE_BLOCK_CONTROL:
+	  dump_BLOCK_CONTROL (&dat, obj);
+	  break;
+	case DWG_TYPE_BLOCK_HEADER:
+	  dump_BLOCK_HEADER (&dat, obj);
+	  break;
+	case DWG_TYPE_LAYER_CONTROL:
+	  dump_LAYER_CONTROL (&dat, obj);
+	  break;
+	case DWG_TYPE_LAYER:
+	  dump_LAYER (&dat, obj);
+	  break;
+	case DWG_TYPE_SHAPEFILE_CONTROL:
+	  dump_SHAPEFILE_CONTROL (&dat, obj);
+	  break;
+	case DWG_TYPE_SHAPEFILE:
+	  dump_SHAPEFILE (&dat, obj);
+	  break;
+	case DWG_TYPE_LTYPE_CONTROL:
+	  dump_LTYPE_CONTROL (&dat, obj);
+	  break;
+	case DWG_TYPE_LTYPE:
+	  dump_LTYPE (&dat, obj);
+	  break;
+	case DWG_TYPE_VIEW_CONTROL:
+	  dump_VIEW_CONTROL (&dat, obj);
+	  break;
+	case DWG_TYPE_VIEW:
+	  dump_VIEW (&dat, obj);
+	  break;
+	case DWG_TYPE_UCS_CONTROL:
+	  dump_UCS_CONTROL (&dat, obj);
+	  break;
+	case DWG_TYPE_UCS:
+	  dump_UCS (&dat, obj);
+	  break;
+	case DWG_TYPE_VPORT_CONTROL:
+	  dump_VPORT_CONTROL (&dat, obj);
+	  break;
+	case DWG_TYPE_VPORT:
+	  dump_VPORT (&dat, obj);
+	  break;
+	case DWG_TYPE_APPID_CONTROL:
+	  dump_APPID_CONTROL (&dat, obj);
+	  break;
+	case DWG_TYPE_APPID:
+	  dump_APPID (&dat, obj);
+	  break;
+	case DWG_TYPE_DIMSTYLE_CONTROL:
+	  dump_DIMSTYLE_CONTROL (&dat, obj);
+	  break;
+	case DWG_TYPE_DIMSTYLE:
+	  dump_DIMSTYLE (&dat, obj);
+	  break;
+	case DWG_TYPE_VP_ENT_HDR_CONTROL:
+	  dump_VP_ENT_HDR_CONTROL (&dat, obj);
+	  break;
+	case DWG_TYPE_VP_ENT_HDR:
+	  dump_VP_ENT_HDR (&dat, obj);
+	  break;
+	case DWG_TYPE_GROUP:
+	  dump_GROUP (&dat, obj);
+	  break;
+	case DWG_TYPE_MLINESTYLE:
+	  dump_MLINESTYLE (&dat, obj);
+	  break;
+	default:
+	  if (obj->type == obj->parent->dwg_ot_layout)
+	    dump_LAYOUT (&dat, obj);
+	  else
+	    printf ("Unknown type: %u\n", obj->type);
+	}
+    }
+  free (dat.chain);
+}
+
+void
+dump_classes (Dwg_Data * dwg)
+{
+  unsigned int i;
+
+  for (i = 0; i < dwg->num_classes; i++)
+    {
+      printf ("[%u] Class number %u:\n", i, dwg->dwg_class[i].number);
+      printf ("  version: %u\n", dwg->dwg_class[i].version);
+      printf ("  appname: %s\n", dwg->dwg_class[i].appname);
+      printf ("  cppname: %s\n", dwg->dwg_class[i].cppname);
+      printf ("  dxfname: %s\n", dwg->dwg_class[i].dxfname);
+      printf ("  wasazombie: %u\n", dwg->dwg_class[i].wasazombie);
+      printf ("  item_class_id: 0x%X\n", dwg->dwg_class[i].item_class_id);
+    }
+}
+
+int
+main (int argc, char *argv[])
+{
+  int fail;
+  Dwg_Data dwg;
+
+  if (1 == argc)
+    {
+      puts ("No input file specified");
+      return -1;
+    }
+
+  dwg.num_objects = 0;
+  fail = dwg_read_file (argv[1], &dwg);
+  if (fail)
+    return (fail);
+
+  puts ("-- DWG dumped data --");
+  printf ("   version: %s\n", dwg_version_code (&dwg));
+  puts ("");
+
+#ifdef SHOW_VAR
+  puts ("-- VARIABLES --");
+  dump_variables (&dwg);
+  puts ("");
+#endif
+
+#ifdef SHOW_CLA
+  puts ("-- CLASSES --");
+  printf ("   num_classes: %lu\n", dwg.num_classes);
+  dump_classes (&dwg);
+  puts ("");
+#endif
+
+#ifdef SHOW_OBJ
+  puts ("-- OBJECTS --");
+  printf ("   num_objects: %lu\n", dwg.num_objects);
+  dump_objects (&dwg);
+  puts ("");
+#endif
+
+  return 0;
+}
diff --git a/examples/dump_objects.in.c b/examples/dump_objects.in.c
new file mode 100644
index 0000000..45920b0
--- /dev/null
+++ b/examples/dump_objects.in.c
@@ -0,0 +1,180 @@
+/*****************************************************************************/
+/*  LibreDWG - free implementation of the DWG file format                    */
+/*                                                                           */
+/*  Copyright (C) 2013 Free Software Foundation, Inc.                        */
+/*                                                                           */
+/*  This library is free software, licensed under the terms of the GNU       */
+/*  General Public License as published by the Free Software Foundation,     */
+/*  either version 3 of the License, or (at your option) any later version.  */
+/*  You should have received a copy of the GNU General Public License        */
+/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.    */
+/*****************************************************************************/
+
+/**
+ *     \file       dump_objects.in.c
+ *     \brief      Dump object contents. It is pre-preprocessed to generate 'dump_objects.c'.
+ *     \author     written by Rodrigo Rodrigues da Silva
+ *     \author     modified by Felipe E. F. de Castro
+ *     \version    
+ *     \copyright  GNU General Public License (version 3 or later)
+ */
+
+/* Definitions copied from ../src/common.h
+ * They are needed in the ".spec" file.
+ */
+#define VERSION(v) if (obj->parent->header.version == v)
+#define VERSIONS(v1,v2) if (obj->parent->header.version >= v1 && obj->parent->header.version <= v2)
+#define OTHER_VERSIONS else
+#define PRE(v) if (obj->parent->header.version < v)
+#define SINCE(v) if (obj->parent->header.version >= v)
+#define PRIOR_VERSIONS else
+#define UNTIL(v) if (obj->parent->header.version <= v)
+#define LATER_VERSIONS else
+/* End of copied definitions  */
+
+#define FIELD(name,type)\
+  printf ("  " #name ": " FORMAT_##type "\n", _obj->name)
+
+#define FIELD_VALUE(name) _obj->name
+
+#define ANYCODE -1
+#define FIELD_HANDLE(name, handle_code)\
+  printf ("  " #name ": HANDLE(%1X.%d.%lu) absolute:%lu\n",\
+        _obj->name->handleref.code,\
+        _obj->name->handleref.size,\
+        _obj->name->handleref.value,\
+        _obj->name->absolute_ref);
+
+#define FIELD_B(name) FIELD(name, B);
+#define FIELD_BB(name) FIELD(name, BB);
+#define FIELD_BS(name) FIELD(name, BS);
+#define FIELD_BL(name) FIELD(name, BL);
+#define FIELD_BD(name) FIELD(name, BD);
+#define FIELD_RC(name) FIELD(name, RC);
+#define FIELD_RS(name) FIELD(name, RS);
+#define FIELD_RD(name) FIELD(name, RD);
+#define FIELD_RL(name) FIELD(name, RL);
+#define FIELD_MC(name) FIELD(name, MC);
+#define FIELD_MS(name) FIELD(name, MS);
+#define FIELD_TV(name) FIELD(name, TV);
+#define FIELD_T FIELD_TV	/*TODO: implement version dependant string fields */
+#define FIELD_BT(name) FIELD(name, BT);
+#define FIELD_4BITS(name) FIELD(name, RC);
+
+#define FIELD_BE(name) printf ("  " #name ": (%g, %g, %g)\n", _obj->name.x, _obj->name.y, _obj->name.z);
+
+#define FIELD_DD(name, _default) FIELD_RD(name)
+#define FIELD_2DD(name, d1, d2) FIELD_DD(name.x, d1); FIELD_DD(name.y, d2);
+#define FIELD_2RD(name) FIELD(name.x, RD); FIELD(name.y, RD);
+#define FIELD_2BD(name) FIELD(name.x, BD); FIELD(name.y, BD);
+#define FIELD_3RD(name) FIELD(name.x, RD); FIELD(name.y, RD); FIELD(name.z, RD);
+#define FIELD_3BD(name) FIELD(name.x, BD); FIELD(name.y, BD); FIELD(name.z, BD);
+#define FIELD_3DPOINT(name) FIELD_3BD(name)
+#define FIELD_CMC(name)\
+    printf ("  " #name ": index %d\n", _obj->name.index);
+
+/* FIELD_VECTOR_N(name, type, size):
+ * reads data of the type indicated by 'type' 'size' times and stores
+ * it all in the vector called 'name' */
+#define FIELD_VECTOR_N(name, type, size)\
+    for (vcount=0; vcount< size; vcount++)\
+      {\
+        printf ("  " #name "[%d]: " FORMAT_##type "\n", vcount, _obj->name[vcount]);\
+      }\
+
+#define FIELD_VECTOR(name, type, size) FIELD_VECTOR_N(name, type, _obj->size)
+
+#define FIELD_2RD_VECTOR(name, size)\
+  for (vcount=0; vcount< _obj->size; vcount++)\
+    {\
+      FIELD_2RD(name[vcount]);\
+    }
+
+#define FIELD_2DD_VECTOR(name, size)\
+  FIELD_2RD(name[0]);\
+  for (vcount = 1; vcount < _obj->size; vcount++)\
+    {\
+      FIELD_2DD(name[vcount], FIELD_VALUE(name[vcount - 1].x), FIELD_VALUE(name[vcount - 1].y));\
+    }
+
+#define FIELD_3DPOINT_VECTOR(name, size)\
+  for (vcount=0; vcount< _obj->size; vcount++)\
+    {\
+      FIELD_3DPOINT(name[vcount]);\
+    }
+
+#define HANDLE_VECTOR_N(name, size, code)\
+  for (vcount=0; vcount<size; vcount++)\
+    {\
+      FIELD_HANDLE(name[vcount], code);\
+    }
+
+#define HANDLE_VECTOR(name, sizefield, code) HANDLE_VECTOR_N(name, FIELD_VALUE(sizefield), code)
+
+#define FIELD_XDATA(name, size)
+
+#define REACTORS(code)\
+  for (vcount=0; vcount<obj->as.object->num_reactors; vcount++)\
+    {\
+      FIELD_HANDLE(reactors[vcount], code);\
+    }
+
+#define XDICOBJHANDLE(code)\
+  if (obj->parent->header.version >= R_2004)\
+    {\
+      if (!obj->as.object->xdic_missing_flag)\
+        FIELD_HANDLE(xdicobjhandle, code);\
+    }\
+  else\
+    {\
+      FIELD_HANDLE(xdicobjhandle, code);\
+    }
+
+#define REPEAT_N(times, name, type) \
+  for (rcount=0; rcount<times; rcount++)
+
+#define REPEAT(times, name, type) \
+  for (rcount=0; rcount<_obj->times; rcount++)
+
+#define REPEAT2(times, name, type) \
+  for (rcount2=0; rcount2<_obj->times; rcount2++)
+
+#define REPEAT3(times, name, type) \
+  for (rcount3=0; rcount3<_obj->times; rcount3++)
+
+#define COMMON_ENTITY_HANDLE_DATA	// Empty
+
+#define DWG_ENTITY(token) \
+void \
+dump_##token (Bit_Chain *dat, Dwg_Object * obj)\
+{\
+  unsigned int vcount, rcount, rcount2, rcount3;\
+  Dwg_Entity_##token *ent, *_obj;\
+  printf ("Entity " #token ":\n");\
+  ent = obj->as.entity->as.token;\
+  _obj=ent;\
+  printf ("  Handle: %1X.%d.%lu\n",\
+    obj->handle.code,\
+    obj->handle.size,\
+    obj->handle.value);
+
+#define DWG_ENTITY_END }
+
+#define DWG_OBJECT(token) \
+void \
+dump_##token (Bit_Chain *dat, Dwg_Object * obj) \
+{ \
+  unsigned int vcount, rcount, rcount2, rcount3;\
+  Dwg_Object_##token *_obj;\
+  printf ("Object " #token ":\n");\
+  _obj = obj->as.object->as.token;\
+  printf ("  Handle: %1X.%d.%lu\n",\
+    obj->handle.code,\
+    obj->handle.size,\
+    obj->handle.value);
+
+#define DWG_OBJECT_END }
+
+#define IS_PRINT
+#include "dwg.spec"
+#undef IS_PRINT
diff --git a/examples/dump_variables.in.c b/examples/dump_variables.in.c
new file mode 100644
index 0000000..d1fcd38
--- /dev/null
+++ b/examples/dump_variables.in.c
@@ -0,0 +1,72 @@
+/*****************************************************************************/
+/*  LibreDWG - free implementation of the DWG file format                    */
+/*                                                                           */
+/*  Copyright (C) 2013 Free Software Foundation, Inc.                        */
+/*                                                                           */
+/*  This library is free software, licensed under the terms of the GNU       */
+/*  General Public License as published by the Free Software Foundation,     */
+/*  either version 3 of the License, or (at your option) any later version.  */
+/*  You should have received a copy of the GNU General Public License        */
+/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.    */
+/*****************************************************************************/
+
+/**
+ *     \file       dump_variables.c.in
+ *     \brief      Dump variables contents. It is pre-preprocessed to generate 'dump_variables.c'.
+ *     \author     written by Rodrigo Rodrigues da Silva
+ *     \author     modified by Felipe E. F. de Castro
+ *     \version    
+ *     \copyright  GNU General Public License (version 3 or later)
+ */
+
+/* Definitions originally copied from ../src/common.h
+ * They are needed in the ".spec" file.
+ */
+#define PRE(v) if (dwg->header.version < v)
+#define UNTIL(v) if (dwg->header.version <= v)
+#define LATER_VERSIONS else
+#define VERSION(v) if (dwg->header.version == v)
+#define VERSIONS(v1,v2) if (dwg->header.version >= v1 && dwg->header.version <= v2)
+#define OTHER_VERSIONS else
+#define SINCE(v) if (dwg->header.version >= v)
+#define PRIOR_VERSIONS else
+/* End of copied definitions  */
+
+#define FIELD(name,type)\
+  printf (#name " = " FORMAT_##type "\n", dwg->header_vars.name);
+
+#define FIELD_VALUE(name) dwg->header_vars.name
+
+#define ANYCODE -1
+#define FIELD_HANDLE(name, handle_code)\
+  printf (#name " = HANDLE(%1X.%d.%lu) absolute:%lu\n",\
+        dwg->header_vars.name->handleref.code,\
+        dwg->header_vars.name->handleref.size,\
+        dwg->header_vars.name->handleref.value,\
+        dwg->header_vars.name->absolute_ref);
+
+#define FIELD_B(name) FIELD(name, B);
+#define FIELD_BB(name) FIELD(name, BB);
+#define FIELD_BS(name) FIELD(name, BS);
+#define FIELD_BL(name) FIELD(name, BL);
+#define FIELD_BD(name) FIELD(name, BD);
+#define FIELD_RC(name) FIELD(name, RC);
+#define FIELD_RS(name) FIELD(name, RS);
+#define FIELD_RD(name) FIELD(name, RD);
+#define FIELD_RL(name) FIELD(name, RL);
+#define FIELD_TV(name) FIELD(name, TV);
+#define FIELD_T FIELD_TV	/*TODO: implement version dependant string fields */
+#define FIELD_BT(name) FIELD(name, BT);
+
+#define FIELD_2RD(name) FIELD(name.x, RD); FIELD(name.y, RD);
+#define FIELD_2BD(name) FIELD(name.x, BD); FIELD(name.y, BD);
+#define FIELD_3RD(name) FIELD(name.x, RD); FIELD(name.y, RD); FIELD(name.z, RD);
+#define FIELD_3BD(name) FIELD(name.x, BD); FIELD(name.y, BD); FIELD(name.z, BD);
+#define FIELD_CMC(name)\
+  printf (#name " = color index %d\n", dwg->header_vars.name.index);
+
+void
+dump_variables (Dwg_Data * dwg)
+{
+#  include "header_variables.spec"
+}
diff --git a/src/bits.h b/src/bits.h
index daeb22d..e890e78 100644
--- a/src/bits.h
+++ b/src/bits.h
@@ -32,21 +32,7 @@
 #ifndef BITS_H
 #define BITS_H
 
-#ifndef DWG_H
 #include "dwg.h"
-#endif
-
-#include "common.h"
-
-/** Structure for DWG-files raw data storage */
-typedef struct _bit_chain
-{
-  unsigned char *chain;
-  long unsigned int size;
-  long unsigned int byte;
-  unsigned char bit;
-  Dwg_Version_Type version;
-} Bit_Chain;
 
 /* Functions for raw data manipulations
  */
diff --git a/src/common.c b/src/common.c
index 7c6e423..9db0c2b 100644
--- a/src/common.c
+++ b/src/common.c
@@ -13,16 +13,16 @@
 /**
  *     \file       common.c
  *     \brief      Common data arrays
- *     \author     written by Felipe Castro
+ *     \author     written and modified by Felipe Castro
  *     \author     modified by Felipe Corrêa da Silva Sances
  *     \author     modified by Rodrigo Rodrigues da Silva
  *     \version    
  *     \copyright  GNU General Public License (version 3 or later)
  */
 
+#include <stdio.h>
 #include "config.h"
 #include "common.h"
-#include "stdio.h"
 
 /** DWG sentinel */
 unsigned char *
@@ -53,8 +53,3 @@ dwg_sentinel(Dwg_Sentinel s)
 }
 
 
-/* TODO: update with new codes */
-/** DWG version codes */
-char version_codes[8][7] =
-  { "------", "AC1012", "AC1014", "AC1015", "AC1018", "AC1021", "AC1024", "------" };
-
diff --git a/src/common.h b/src/common.h
index 1de55ee..ee07755 100644
--- a/src/common.h
+++ b/src/common.h
@@ -13,7 +13,7 @@
 /**
  *     \file       common.h
  *     \brief      Common general functions and macro
- *     \author     written by Felipe Castro
+ *     \author     written and modified by Felipe Castro
  *     \author     modified by Felipe Corrêa da Silva Sances
  *     \author     modified by Rodrigo Rodrigues da Silva
  *     \version    
@@ -32,44 +32,6 @@
 #define UNTIL(v) if (dat->version <= v)
 #define LATER_VERSIONS else
 
-/** DWG version type */
-typedef enum DWG_VERSION_TYPE
-{
-  R_BEFORE, R_13, R_14, R_2000, R_2004, R_2007, R_2010, R_AFTER
-} Dwg_Version_Type;
-extern char version_codes[8][7];
-
-/** Data types (including compressed forms) used trough the file */
-typedef enum DWG_DATA_TYPE
-{
-  DWG_DT_B,   /**< bit (1 or 0) */
-  DWG_DT_BB,  /**< special 2-bit code (entmode in entities, for instance) */
-  DWG_DT_RC,  /**< raw char (not compressed) */
-  DWG_DT_RS,  /**< raw short (not compressed) */
-  DWG_DT_RD,  /**< raw double (not compressed) */
-  DWG_DT_RL,  /**< raw long (not compressed) */
-  DWG_DT_BS,  /**< bitshort */
-  DWG_DT_BL,  /**< bitlong */
-  DWG_DT_BD,  /**< bitdouble */
-  DWG_DT_MC,  /**< modular char */
-  DWG_DT_MS,  /**< modular short  */
-  DWG_DT_BE,  /**< BitExtrusion */
-  DWG_DT_DD,  /**< BitDouble With Default */
-  DWG_DT_BT,  /**< BitThickness */
-  DWG_DT_H,   /**< handle reference (see the HANDLE REFERENCES section) */
-  DWG_DT_CMC, /**< CmColor value */
-  DWG_DT_T,   /**< text (bitshort length, followed by the string) */
-  DWG_DT_TU,  /**< Unicode text (bitshort character length, followed by
-                   Unicode string, 2 bytes per character). Unicode text
-                   is read from the “string stream” within the object data,
-                   see the main Object description section for details. */
-  DWG_DT_2RD, /**< 2 raw doubles */
-  DWG_DT_3RD, /**< 3 raw doubles */
-  DWG_DT_2BD, /**< 2D point (2 bitdoubles) */
-  DWG_DT_3BD, /**< 3D point (3 bitdoubles) */
-  DWG_END_OF_HEADER_VARIABLES
-} Dwg_Data_Type;
-
 /** References of sentinels */
 typedef enum DWG_SENTINEL
 {
@@ -84,9 +46,6 @@ typedef enum DWG_SENTINEL
   DWG_SENTINEL_SECOND_HEADER_END
 } Dwg_Sentinel;
 
-Dwg_Data_Type
-dwg_var_map(Dwg_Version_Type version, int index);
-
 unsigned char *
 dwg_sentinel(Dwg_Sentinel sentinel);
 
